package eu.dnetlib.uoamonitorservice.dao;

import eu.dnetlib.uoamonitorservice.entities.Stakeholder;
import org.springframework.data.mongodb.repository.MongoRepository;

import java.util.List;

public interface MongoDBStakeholderDAO extends StakeholderDAO, MongoRepository<Stakeholder, String> {
    List<Stakeholder> findAll();
    List<Stakeholder> findByType(String Type);

    List<Stakeholder> findByDefaultId(String DefaultId);
    List<Stakeholder> findByDefaultIdAndType(String DefaultId, String Type);

    List<Stakeholder> findByDefaultIdNot(String DefaultId);
    List<Stakeholder> findByDefaultIdNotAndType(String DefaultId, String Type);

    Stakeholder findByTopicsContaining(String topic);

    Stakeholder findById(String Id);
    Stakeholder findByAlias(String Alias);

    void delete(String Id);

    Stakeholder save(Stakeholder stakeholder);
}
